# 技术路线概要

## 协作白板

### 主要的功能列表

#### 画布管理
##### 新增
##### 查看
##### 删除
##### 查看

#### 权限管理
##### 开通权限
##### 修改/删除权限

#### 协作
#### 新写作者加入
```
1.前端打开一个文档时，发送请求给服务端，服务端检查协作列表中是否有当前文档。
2.如果有则把当前用户加入此文档修改者列表；如果没有就把当前文档加入协作列表，同时把当前用户ID写入其中。
3.服务端通过长链接给文档列表中的所有其他用户推送消息，告知大家有用户加入协作。
```
#### 数据提交
```
1.前端把修改数据发送给服务端
2.服务端暂存多个用户的操作，并根据OT算法把用户操作合并，最后和数据库存储的文档内容合并
3.把合并完的文档内容保存到数据库中
4.服务端根据文档ID，读取协作列表中的用户，给所有用户发送合并结果
5.客户端把合并结果与本地文档内容合并
```
##### 合并冲突
##### 协作通知
##### 离线暂存

### 数据结构化存储/解析
```
通过json存取
```

### 数据建模
```
参见类型描述文档./types/board.ts
```
### 导出
```
//导出成pdf
canvas2pdf
```

### 进阶
如果对传输文件大小或者性能有更高要求,可以基于Protobuf协议来替换json

## 多人协作编辑器

#### 文稿管理
##### 新增
##### 查看
##### 删除
##### 查看

#### 权限管理
##### 权限分类
管理权限、编辑权限、查看权限、无权限
##### 开通权限
##### 修改/删除权限

#### 协作
#### 新写作者加入
```
1.权限校验,如有权限则拉取文档内容。
2.ws通知其他正在修改同一个文稿的人，有新的协作者加入
```
#### 数据提交
```
1.前端把修改数据发送给服务端
1.1 将变更请求变为阻塞的同步请求
1.2 前端每次请求都生成连续递增的ID，服务端判断如果递增ID不连续了，就短暂的等待
1.3 服务端队列接受，按照连续递增的ID消费。
```
##### 合并冲突
```
1.服务端OT算法合并
2.把合并完的文档内容保存到数据库中,并生成修改记录
3.通过ws给所有的协作者同步最新结果
4.客户端merge云端和本地内容，渲染
```
##### 协作通知
ws
##### 离线暂存
本地通过队列暂存请求失败的数据包,每30S重试一次最小序号的包，如果成功提交则进行下一个
#### 备注
OT算法https://zhuanlan.zhihu.com/p/634121875

## 严肃游戏

## PPT
